#ifndef __AB_MAIN_HPP__
#define __AB_MAIN_HPP__

// strings in lng file
enum {
  mName,
  mUnknown,
  mDefault,
  mLoading,
  mConfigMenu1,
  mConfigMenu2,
  mConfigMenu3,
  mConfigMenu4,
  mConfigDialogActive,
  mConfigDialogColorizeAll,
  mConfigDialogMaxLines,
  mConfigSave,
  mConfigCancel,
  mColorMain,
  mColorForeground,
  mColorBackground,
  mColorTest1,
  mColorTest2,
  mColorTest3,
  mColorSet,
  mColorCancel,
  mStopQuestion,
  mFatalLine1,
  mFatalLine2,
  mButtonOk,
  mButtonYes,
  mButtonNo,
  mError,
};

char *GetMsg(int MsgId);
char *GetCommaWord(char *Src,char *Word);

typedef unsigned long (WINAPI *PLUGINLOADSYNTAXMODULE)(char *ModuleName,void *Info);
typedef int (WINAPI *PLUGINSETCOLORIZEINFO)(struct ColorizeInfo *AInfo);
typedef int (WINAPI *PLUGINGETPARAMS)(int index,int command,char **param);
typedef void (WINAPI *PLUGINCOLORIZE)(int index,struct ColorizeParams *params);
typedef unsigned long (WINAPI *PLUGINGETSYNTAXCOUNT)(void);
typedef void (WINAPI *PLUGINEXIT)(void);

struct PluginItem
{
  HMODULE hModule;
  int Index;
  int Type;
  char *Name;
  char *Mask;
  char *Start;
  int Params;
  PLUGINLOADSYNTAXMODULE pLoadSyntaxModule;
  PLUGINSETCOLORIZEINFO pSetColorizeInfo;
  PLUGINGETPARAMS pGetParams;
  PLUGINCOLORIZE pColorize;
  PLUGINGETSYNTAXCOUNT pGetSyntaxCount;
  PLUGINEXIT pExit;
};

extern struct PluginItem *PluginsData;
extern int PluginsCount;

struct StateCache
{
  unsigned long data_size;
  unsigned char *data;
  StateCache *next;
};

typedef struct CEditFile *PEditFile;

struct CEditFile
{
  int id;
  bool main;
  PEditFile next, prev;
//
  StateCache *cache;
  int cachesize;
  int type;
};

//struct CEditFile methods
extern PEditFile ef_create(bool m = false);
extern void ef_free(PEditFile value);
extern PEditFile ef_getfile(int fid);
extern PEditFile ef_addfile(int fid);
extern bool ef_deletefile(int fid);

extern PEditFile editfiles;

extern PEditFile loadfile(int eid,int type);

extern void OnLoad(void);
extern void OnExit(void);
extern void OnConfigure(void);
extern int OnEditorEvent(int event, void *param);

#define PARSER_CACHESTR 50
#define FAR165_INFO_SIZE 336

extern PluginStartupInfo Info;
extern FARSTANDARDFUNCTIONS FSF;
extern HANDLE Mutex;
extern int cursor_row,cursor_col;
extern char PluginRootKey[];
extern char PluginMaskKey[];
extern char PluginColorKey[];
extern char PluginStartKey[];

extern void LoadPlugs(const char *ModuleName);
extern void UnloadPlugs(void);

struct InitDialogItem
{
  int Type;
  int X1,Y1,X2,Y2;
  int Focus;
  int Selected;
  unsigned int Flags;
  int DefaultButton;
  char *Data;
};

extern void InitDialogItems(InitDialogItem *Init,FarDialogItem *Item,int ItemsNumber);
extern bool SelectColor(int *fg,int *bg);

struct Options
{
  bool Active;
  int MaxLines;
  bool ColorizeAll;
};

extern struct Options Opt;
extern bool fatal;

#endif
