#include <ctype.h>
#define YYCTYPE unsigned char
#define YYCURSOR (*yycur)
#define YYLIMIT yyend
#define YYMARKER yytmp
#define YYFILL(n)
#define PARAM_CHAR_CLASS (((struct CharacterClassParam *)cc_param)->char_class->Class)
#define GET_CHAR(res) \
{ \
  res=*cc_cur; \
  cc_cur++; \
  if(res=='\\') \
  { \
    switch(*cc_cur) \
    { \
      case 'n': \
        res='\n'; \
        break; \
      case 'r': \
        res='\r'; \
        break; \
      case 't': \
        res='\t'; \
        break; \
      case 's': \
        res=' '; \
        break; \
      default: \
      { \
        res=-1; \
        if(isdigit(*cc_cur)) \
        { \
          unsigned char *cc_new; \
          int val=strtol((char *)cc_cur,(char **)&cc_new,8); \
          if((val<256)&&(val>-1)) \
          { \
            cc_cur=cc_new-1; \
            res=val; \
          } \
        } \
        if(res==-1) \
          res=*cc_cur; \
      } \
    } \
    cc_cur++; \
  } \
}

/*!re2c
full = [\000-\377];
any = [\001-\377];
esc = any \ [\\];
cstring = "[" ((esc \ [\]]) | "\\" any)* "]";
digit = [0-9];
*/
int yylex(YYSTYPE *yylval,void *cc_param)
{
  unsigned char *yyend=((struct CharacterClassParam *)cc_param)->end;
  unsigned char **yycur=&(((struct CharacterClassParam *)cc_param)->start);
  unsigned char *yytmp,*yytok=NULL;
lexer_clear:
  yytok=*yycur;
/*!re2c
  cstring
  {
    int action=1;
    unsigned char *cc_cur=yytok+1,*cc_end=(*yycur)-1;
    int first_char,last_char;
    if(*cc_cur=='^')
    {
      action=0;
      cc_cur++;
    }
    memset(PARAM_CHAR_CLASS,!action,sizeof(PARAM_CHAR_CLASS));
    while(cc_cur<cc_end)
    {
      GET_CHAR(first_char)
      if((*cc_cur=='-')&&((cc_end-cc_cur)>1))
      {
        cc_cur++;
        GET_CHAR(last_char)
        for(int i=first_char;i<=last_char;i++)
          PARAM_CHAR_CLASS[i]=action;
      }
      else
        PARAM_CHAR_CLASS[first_char]=action;
    }
    return CLASS;
  }
  digit+
  {
    yylval->digit=atoi((char *)yytok);
    return DIGIT;
  }
  [*+?{},] { return *yytok; }
  [ \t\v\f]+ { goto lexer_clear; }
  full
  {
    if(yytok==yyend) goto lexer_end;
    goto lexer_clear;
  }
*/
lexer_end:
  return 0;
}
