%{
#include <limits.h>
#include <stdlib.h>
#include <windows.h>
#include "abzcustom.h"
#include "../../memory.h"
#define YYPARSE_PARAM cc_param
#define YYPURE
#define YYLEX_PARAM YYPARSE_PARAM
#define PARAM_MIN (((struct CharacterClassParam *)cc_param)->char_class->min)
#define PARAM_MAX (((struct CharacterClassParam *)cc_param)->char_class->max)
int yyerror(char *msg);

%}
%union
{
  unsigned int digit;
}

%token CLASS
%token <digit> DIGIT

%{
int yylex(YYSTYPE *yylval,void *cc_param);
%}

%%

list:   '\0'                            {}
        | exp '\0'                      {}
;

exp:    CLASS                           { PARAM_MIN=1; PARAM_MAX=1; }
        | CLASS '*'                     { PARAM_MIN=0; PARAM_MAX=INT_MAX; }
        | CLASS '+'                     { PARAM_MIN=1; PARAM_MAX=INT_MAX; }
        | CLASS '?'                     { PARAM_MIN=0; PARAM_MAX=1; }
        | CLASS '{' DIGIT ',' '}'       { PARAM_MIN=$3; PARAM_MAX=INT_MAX; }
        | CLASS '{' DIGIT ',' DIGIT '}' { PARAM_MIN=$3; PARAM_MAX=$5; }
;

%%

int yyerror(char *msg)
{
  return 0;
}

#include "../../bootstrap/zc_lexer.cpp"